﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

        DataSet set = new DataSet();
        //Add two tables
        set.Tables.Add(BuildTable("Parent"));
        set.Tables.Add(BuildChildTable("Child"));

        //Create relations
        DataColumn parentColumn = set.Tables[0].Columns["id"];
        DataColumn childColumn = set.Tables[1].Columns["relation"];
        DataRelation relation = new DataRelation("RelationName", parentColumn, childColumn);
        set.Relations.Add(relation);

        this.WebHierarchicalDataGrid1.DataSource = set;
        this.WebHierarchicalDataGrid1.DataBind();

    }
    private DataTable BuildTable(string name)
    {

        System.Data.DataTable table = new DataTable(name);
        DataColumn column;
        DataRow row;

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;

        for (int i = 0; i <= 20; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = "Item " + i;
            row["Data"] = "Data " + i;
            table.Rows.Add(row);
        }
        return table;

    }

    private DataTable BuildChildTable(string name)
    {
        System.Data.DataTable table = new DataTable(name);
        DataColumn column;
        DataRow row;

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);


        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "relation";
        column.AutoIncrement = false;
        column.Caption = "relation";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;

        for (int i = 0; i <= 100; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = "Item " + i;
            row["Data"] = "Data " + i;

            if ((i < 10) && (i >= 0))
            {

                row["relation"] = 0;
            }
            else if ((i < 20) && (i >= 10))
            {
                row["relation"] = 1;
            }
            else if ((i < 30) && (i >= 20))
            {
                row["relation"] = 2;
            }
            else if ((i < 40) && (i >= 30))
            {
                row["relation"] = 3;
            }
            else if ((i < 50) && (i >= 40))
            {
            }
            table.Rows.Add(row);
        }
        return table;

    }
    protected void WebHierarchicalDataGrid1_RowIslandsPopulating(object sender, Infragistics.Web.UI.GridControls.ContainerRowCancelEventArgs e)
    {
        e.Cancel = true;

        int key = (int)e.Row.DataKey[0];

        DataTable childData = BuildChildTable("ChildTable");
        childData.DefaultView.RowFilter = "id = "+key.ToString();


        ContainerGrid childGrid = new ContainerGrid();        
       
        e.Row.RowIslands.Add(childGrid);
        //We disable the autogenerated columns and create the columns so that we can have access to them in the columns collection
        childGrid.AutoGenerateColumns = false;

        BoundDataField idCol = new BoundDataField();
        idCol.DataFieldName = "id";
        idCol.Key = "id";
        idCol.Header.Text = "id";

        BoundDataField itemCol = new BoundDataField();
        itemCol.DataFieldName = "Item";
        itemCol.Key = "ItemChild";
        itemCol.Header.Text = "Item";

        BoundDataField dataCol = new BoundDataField();
        dataCol.DataFieldName = "Data";
        dataCol.Key = "Data";
        dataCol.Header.Text = "Data";

        BoundDataField relCol = new BoundDataField();
        relCol.DataFieldName = "relation";
        relCol.Key = "relation";
        relCol.Header.Text = "relation";

        childGrid.Columns.Add(idCol);
        childGrid.Columns.Add(itemCol);
        childGrid.Columns.Add(dataCol);
        childGrid.Columns.Add(relCol);

        childGrid.DataSource = childData;
        childGrid.DataBind();

        if (childGrid.Behaviors.EditingCore == null)
        {
            childGrid.Behaviors.CreateBehavior<EditingCore>();
        }

        if (childGrid.Behaviors.EditingCore.Behaviors.CellEditing == null)
        {
            childGrid.Behaviors.EditingCore.Behaviors.CreateBehavior<CellEditing>();
        }


        ColumnEditSetting settings = new ColumnEditSetting();
        settings.ColumnKey = "id";
        settings.ReadOnly = true;
        childGrid.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(settings);
    }
    protected void WebHierarchicalDataGrid1_InitializeBand(object sender, BandEventArgs e)
    {

    }
}